<?php

namespace StructType;

use \WsdlToPhp\PackageBase\AbstractStructBase;

/**
 * This class stands for VehicleGeozoneResult StructType
 * @subpackage Structs
 */
class VehicleGeozoneResult extends AbstractStructBase
{
    /**
     * The Id
     * Meta information extracted from the WSDL
     * - maxOccurs: 1
     * - minOccurs: 1
     * @var int
     */
    public $Id;
    /**
     * The ObcDateTime
     * Meta information extracted from the WSDL
     * - maxOccurs: 1
     * - minOccurs: 1
     * @var string
     */
    public $ObcDateTime;
    /**
     * The Name
     * Meta information extracted from the WSDL
     * - maxOccurs: 1
     * - minOccurs: 0
     * @var string
     */
    public $Name;
    /**
     * Constructor method for VehicleGeozoneResult
     * @uses VehicleGeozoneResult::setId()
     * @uses VehicleGeozoneResult::setObcDateTime()
     * @uses VehicleGeozoneResult::setName()
     * @param int $id
     * @param string $obcDateTime
     * @param string $name
     */
    public function __construct($id = null, $obcDateTime = null, $name = null)
    {
        $this
            ->setId($id)
            ->setObcDateTime($obcDateTime)
            ->setName($name);
    }
    /**
     * Get Id value
     * @return int
     */
    public function getId()
    {
        return $this->Id;
    }
    /**
     * Set Id value
     * @param int $id
     * @return \StructType\VehicleGeozoneResult
     */
    public function setId($id = null)
    {
        // validation for constraint: int
        if (!is_null($id) && !(is_int($id) || ctype_digit($id))) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide an integer value, %s given', var_export($id, true), gettype($id)), __LINE__);
        }
        $this->Id = $id;
        return $this;
    }
    /**
     * Get ObcDateTime value
     * @return string
     */
    public function getObcDateTime()
    {
        return $this->ObcDateTime;
    }
    /**
     * Set ObcDateTime value
     * @param string $obcDateTime
     * @return \StructType\VehicleGeozoneResult
     */
    public function setObcDateTime($obcDateTime = null)
    {
        // validation for constraint: string
        if (!is_null($obcDateTime) && !is_string($obcDateTime)) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide a string, %s given', var_export($obcDateTime, true), gettype($obcDateTime)), __LINE__);
        }
        $this->ObcDateTime = $obcDateTime;
        return $this;
    }
    /**
     * Get Name value
     * @return string|null
     */
    public function getName()
    {
        return $this->Name;
    }
    /**
     * Set Name value
     * @param string $name
     * @return \StructType\VehicleGeozoneResult
     */
    public function setName($name = null)
    {
        // validation for constraint: string
        if (!is_null($name) && !is_string($name)) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide a string, %s given', var_export($name, true), gettype($name)), __LINE__);
        }
        $this->Name = $name;
        return $this;
    }
}
